%---------------------------
% Filename: Lx.m
%---------------------------
%
% This is a function code to define the following matrix
%           Lx = | x1  x2^T |
%                | x2  x1*I |
% Lx(x) =  L_x , where x is a column vector.
%


  function  A = Lx(x)

  nn = length(x);

  x1 = x(1);
  x2 = x(2:nn);

  A = zeros(nn,nn);  % set up the dimension of matrix A

  A(1,1) = x1;

  A(1,2:nn) = x2';

  A(2:nn,1) = x2;

  A(2:nn,2:nn) = x1*eye(nn-1);