
function [phixy,trx,e,Vx, Vy] = profun(x,y);

global n nl nq nr;


null = 10^(-20);

P = [];

V = sparse(zeros(length(x)));

trx = 0;

e = zeros(1,n);

if nl > 0 
    
   zla = x(1:nl) - y(1:nl);
   
   P = max(0,zla);
   
   if nargout >= 3
       
        for i = 1:nl 
       
           if zla(i) > 0 
               
               V(i,i) = 1;
           
           elseif zla(i)<0
               
               V(i,i) = 0;
           
           else
               
                V(i,i) = rand(1,1);
           end   
           e(i) = 1;
       end 

   end
  trx  = trx + sum(x(1:nl));  
end



for i = 1:nq
    
    ni1 = nr(i);   ni2 = nr(i+1)-1;
    
    xi = x(ni1:ni2);   ni = length(xi);  
    
    xi1 = xi(1);  xi2 = xi(2:end);
    
    yi = y(ni1:ni2);   
    
    yi1 = yi(1);  yi2 = yi(2:end);
 
    zi = xi - yi;   nzi = norm(zi(2:end));

     if nzi > null
         
         PP = 0.5*max(0,zi(1)-nzi)*[1; -zi(2:end)/nzi] + 0.5*max(0,zi(1)+nzi)*[1; zi(2:end)/nzi];
         
     else
    
         PP = max(0,zi(1)-nzi)*[1; zeros(ni-1,1)];
         
     end
     
     P = [P;PP];
     
     if nargout >= 3
         
     if abs(abs(zi(1))-nzi) > null

         if zi(1) < -nzi
             
             VV = zeros(ni);
                   
         elseif zi(1) > nzi
        
             VV = eye(ni);
                        
         else
             wi = zi(2:end)/nzi;
             
             H = (zi(1)/nzi + 1)*eye(ni-1) - zi(1)/nzi*wi*wi';
             
             VV = 0.5*[1, wi'; wi, H];                      
         end
         
         
     elseif nzi > null && zi(1) > 0
         
         wi = zi(2:end)/nzi;
         
         H = 2*eye(ni-1) - wi*wi';
         
         VV = 0.5*[1, wi'; wi, H];
                     
     elseif nzi > null && zi(1) < 0
         
         wi = zi(2:end)/nzi;
         
         H = wi*wi';
         
         VV = 0.5*[1, wi'; wi, H];
                    
     else
         VV = eye(ni);
        
     end
     
     V(ni1:ni2,ni1:ni2) = VV;
  
     end
     trx = trx + 2*xi1;
     e(ni1:ni2) = [2,zeros(1,ni-1)];
end

phixy = x - P;

if nargout >= 3
    Vx = eye(length(x)) - V;
    Vy = V;
end

