
function [xp,trx,e,Vx] = profun(x);

global n nl nq nr A;

null = 10^(-20);

P = [];

V = sparse(zeros(length(x)));

e = zeros(1,n);

trx = 0;

if nl > 0 
    
   zla = x(1:nl);
   
   P = max(0,zla);
   
   if nargout >= 3
       
        for i = 1:nl 
       
           if zla(i) > 0 
               
               V(i,i) = 1;
           
           elseif zla(i)<0
               
               V(i,i) = 0;
           
           else
               
                V(i,i) = rand(1,1);
           end   
           
           e(i) = 1;
                
       end 
      AVx(1:nl,1:nl) = A(1:nl,1:nl)*V(1:nl,1:nl)
   end
  trx = trx + sum(x(1:nl));
  
end



for i = 1:nq
    
    ni1 = nr(i);    ni2 = nr(i+1)-1;
    
    zi = x(ni1:ni2);   ni = length(zi);
    
    zi1 = zi(1);  zi2 = zi(2:end);
    
    nzi = norm(zi(2:end));

     if nzi > null
         
         PP = 0.5*max(0,zi1-nzi)*[1; -zi2/nzi] + 0.5*max(0,zi1+nzi)*[1; zi2/nzi];
         
     else
         
         PP = max(0,zi1-nzi)*[1; zeros(ni-1,1)];
         
     end
     
     P = [P;PP];
     
     if nargout >=3
         
     if abs(abs(zi1) - nzi) > null
         
         if zi1 < -nzi
             
             VV = zeros(ni);
                        
         elseif zi1 > nzi
             
             VV = eye(ni);
                        
         else
             wi = zi2/nzi;
             H = (zi1/nzi + 1)*eye(ni-1) - zi1/nzi*wi*wi';
             VV = 0.5*[1, wi'; wi, H];           
            
         end
         
     elseif nzi > null && zi1 > 0
         
         wi = zi2/nzi;
         H = 2*eye(ni-1) - wi*wi';
         VV = 0.5*[1, wi'; wi, H];
        
             
     elseif nzi > null && zi1 < 0
         
         wi = zi2/nzi;
         H = wi*wi';
         VV = 0.5*[1, wi'; wi, H];
                    
     else 
         
         VV = eye(ni);
        
     end
     
     V(ni1:ni2,ni1:ni2) = VV;
  
     end
     
     trx = trx + 2*zi1;
     
     e(ni1:ni2) = [2,zeros(1,ni-1)];
end

xp = P;

if nargout >= 3
    Vx = V;
end

