%-----------------------------------------------------------------------
%  starting.m
% 
%------------------------------------------------------------------------
%
% This file is used to generate the starting point (z0,lamd0) for 
% the normal system reformulation of Lorentz eigenvalue problem 
%  
%   x\in\K, Ax - lamd*x \in K,  <x, Ax - lamd*x>=0, 
%


function [x0,lamd0] = starting(n,nq,A);


x0 = zeros(n,1);  

nk = n/nq;

for j = 1:nq
    
    x1 = rand(nk,1);                               
    
    x0((j-1)*nk+1:j*nk)= -1*ones(nk,1) + 2*x1; 
   
   % x0((j-1)*nk+1:j*nk)= -100*ones(nk,1) + 200*x1; 

end   

y0 = profun(x0) ;    
 
% y0 = x0;
 
lamd0 = (y0'*(A*y0))/(y0'*y0);



